void speed_plus(int theValue){
  setWind(direction_degrees, wind_mph+5);
  tinkerStatus();
}

void speed_minus(int theValue){
  setWind(direction_degrees, wind_mph-5);
  tinkerStatus();
}

void speed_set(int theValue){
  
  float speed;
  
  if (metric) {
    speed = float(JOptionPane.showInputDialog(frame, "Enter windspeed (kph):", "Set Windspeed", JOptionPane.PLAIN_MESSAGE));
    speed = speed * 0.621371;
  } else {
    speed = float(JOptionPane.showInputDialog(frame, "Enter windspeed (mph):", "Set Windspeed", JOptionPane.PLAIN_MESSAGE));
  }
  
  if (!Float.isNaN(speed) && speed >= 0){
    setWind(direction_degrees, speed);
    tinkerStatus();
  } else {
    errorStatus();
  }
}

void direction_plus(int theValue){
  setWind(direction_degrees + 15, wind_mph);
  tinkerStatus();
}

void direction_minus(int theValue){
  setWind(direction_degrees - 15, wind_mph);
  tinkerStatus();
}

void direction_set(int theValue){
  int dir = int(JOptionPane.showInputDialog(frame, "Enter direction (degrees from north)", "Set Wind Direction", JOptionPane.PLAIN_MESSAGE));
  
  if (!Float.isNaN(dir)){
    setWind(dir, wind_mph);
    tinkerStatus();
  } else {
    errorStatus();
  }
}

void temp_plus(int theValue){
  setTemp(temp_f+5);
  tinkerStatus();
}

void temp_minus(int theValue){
  setTemp(temp_f-5);
  tinkerStatus();
}

void temp_set(int theValue){
  
  float temp;
  
  if (metric) {
    temp = float(JOptionPane.showInputDialog(frame, "Enter temperature (C):", "Set Temperature", JOptionPane.PLAIN_MESSAGE));
    temp = CtoF(temp);
  } else {
    temp = float(JOptionPane.showInputDialog(frame, "Enter temperature (F)", "Set Temperature", JOptionPane.PLAIN_MESSAGE));
  }
  
  if (!Float.isNaN(temp)){
    normalAir();
    setTemp(temp);
    status = "Temperature set. Air composition reset to normal Earth.";
  } else {
    errorStatus();
  }
}

void hum_plus(int theValue){
  setHum(rel_hum+.05, pressure);
  tinkerStatus();
}

void hum_minus(int theValue){
  setHum(rel_hum-.05, pressure);
  tinkerStatus();
}

void hum_set(int theValue){
  float hum = float(JOptionPane.showInputDialog(frame, "Enter relative humidity (%):", "Set Humidity", JOptionPane.PLAIN_MESSAGE));
  
  if (!Float.isNaN(hum) && hum >= 0 && hum <= 100){
    setHum(hum/100, pressure);
    tinkerStatus();
  } else {
    errorStatus();
  }
}

void pres_plus(int theValue){
  setHum(rel_hum, pressure+1);
  tinkerStatus();
}

void pres_minus(int theValue){
  setHum(rel_hum, pressure-1);
  tinkerStatus();
}

void pres_set(int theValue){
  
  float pres;
  
  if (metric) {
    pres = float(JOptionPane.showInputDialog(frame, "Enter barometric pressure (millibars):", "Set Pressure", JOptionPane.PLAIN_MESSAGE));
  } else {
    pres = float(JOptionPane.showInputDialog(frame, "Enter barometric pressure (inches):", "Set Pressure", JOptionPane.PLAIN_MESSAGE));
    pres = pres * 33.8639;
  }
  
  if (!Float.isNaN(pres) && pres >= 0){
    setHum(rel_hum, pres);
    reboot();
    rebootStatus();
  } else {
    errorStatus();
  }
}
  
void co2_plus(int theValue){
  setAir(co2_prop + .000025, .2095, .7809, .00933);
  status = "CO2 added. Air composition reset to normal Earth.";
}

void co2_minus(int theValue){
  setAir(co2_prop - .000025, .2095, .7809, .00933);
  status = "CO2 removed. Air composition reset to normal Earth.";
}

void co2_set(int theValue){
  float co2 = float(JOptionPane.showInputDialog(frame, "Enter carbon dioxide (ppm):", "Set Carbon Dioxide", JOptionPane.PLAIN_MESSAGE));
  co2 = co2/1000000;
  
  if (!Float.isNaN(co2) && co2 >= 0){
     setAir(co2, oxygen_prop, nitrogen_prop, argon_prop);
     reboot();
     rebootStatus();
  } else {
    errorStatus();
  }
    
}

void system_switch(boolean theValue){
  
  metric = !metric;
  
  if (metric) {
    cp5.getController("system_switch").setCaptionLabel("Metric");
  } else {
    cp5.getController("system_switch").setCaptionLabel("U.S.");
  }
}

//CALL ON THE WEATHER GODS -- Uses the OpenWeather API  
void internet(int theValue) {
  
  String ZIP = JOptionPane.showInputDialog(frame, "Enter a ZIP code:", "Get Weather Data", JOptionPane.PLAIN_MESSAGE);
  String URL = "http://api.openweathermap.org/data/2.5/weather?zip=" + ZIP + "&units=imperial&forecast?id=524901&APPID=f76d1e93101b404983a4d64099be7379";
                  
  JSONObject weatherConditions= loadJSONObject(URL);
  JSONObject wind;
          
  //Error checking for invalid input
   if (weatherConditions.isNull("main")) {
            errorStatus();
   } else {
          
          wind = weatherConditions.getJSONObject("wind");
          weatherConditions = weatherConditions.getJSONObject("main");
          float get_temp = weatherConditions.getFloat("temp");
          //JOptionPane.showMessageDialog(frame, "The temp is " + get_temp, "Test", JOptionPane.INFORMATION_MESSAGE);
          float get_hum = weatherConditions.getFloat("humidity");
          //JOptionPane.showMessageDialog(frame, "The humidity is " + get_hum, "Test", JOptionPane.INFORMATION_MESSAGE);
          float get_pres = weatherConditions.getFloat("pressure");
          //JOptionPane.showMessageDialog(frame, "The pressure is " + get_pres, "Test", JOptionPane.INFORMATION_MESSAGE);
          float get_windspeed = wind.getFloat("speed");
          //JOptionPane.showMessageDialog(frame, "The windspeed is " + get_windspeed, "Test", JOptionPane.INFORMATION_MESSAGE);
          int get_direction = wind.getInt("deg");
          //JOptionPane.showMessageDialog(frame, "The wind direction is " + get_direction, "Test", JOptionPane.INFORMATION_MESSAGE);
          
          status = "AirScope is using real weather data.";
          
          normalAir();
          setWind(get_direction, get_windspeed);
          setTemp(get_temp);
          setHum(get_hum, get_pres);
          
          reboot();
    }
}

void venus(int theValue){
  setAir(.965,0,.035,0);
  setWind(int(random(360)), 220);
  setTemp(872);
  setHum(0, 93);
  status= "AirScope is showing the air on planet Venus.";
  reboot();
}

void rainforest(int theValue){
  normalAir();
  setWind(int(random(360)), 0);
  setTemp(80);
  setHum(.83, 1015);
  status= "AirScope is showing air from the Amazon rainforest.";      
  reboot();          
}

void sahara(int theValue){
  normalAir();
  setWind(int(random(360)), 0);
  setTemp(104);
  setHum(0.05, 1030);
  status= "AirScope is showing air from the summer Sahara Desert.";
  reboot();         
}

void southpole(int theValue){
  normalAir(); //https://icecube.wisc.edu/pole/weather
  setWind(20, 12.3);
  setTemp(-57.1);
  setHum(0, 681.2);
  status= "AirScope is showing air from the South Pole.";
  reboot();        
}

void probe(int theValue){
  
 JOptionPane.showMessageDialog(frame, "Not included in this demo. This button would grab temperature, humidity, and pressure data from the air if you had the special AirScope magnifying lens.", "Lens Function", JOptionPane.PLAIN_MESSAGE);
 
}

void about(int theValue) {
  JOptionPane.showMessageDialog(frame, "Designed and programmed by Marc Campasano\nfor 'Beyond Bits and Atoms' at Stanford University\n\nLocal weather from OpenWeather", "About AirScope", JOptionPane.PLAIN_MESSAGE);
}

void tinkerStatus() {
  status = "You are experimenting with the air values.";
}

void errorStatus() {
  status = "That didn't quite work. Try again.";
}

void rebootStatus() {
  status = "AirScope regenerated its visualization.";
}