void setupGUI() {
 cp5 = new ControlP5(this);
  
  cp5.addButton("speed_plus")
  .setPosition(WINDOWX+10, 40)
  .setSize(15, 15)
  .setCaptionLabel("+");
  
  cp5.addButton("speed_minus")
  .setPosition(WINDOWX+30, 40)
  .setSize(15, 15)
  .setCaptionLabel("-");
  
  cp5.addButton("speed_set")
  .setPosition(WINDOWX+50, 40)
  .setSize(30, 15)
  .setCaptionLabel("set");
  
  cp5.addButton("direction_plus")
  .setPosition(WINDOWX+10, 60)
  .setSize(15, 15)
  .setCaptionLabel("+");
  
  cp5.addButton("direction_minus")
  .setPosition(WINDOWX+30, 60)
  .setSize(15, 15)
  .setCaptionLabel("-");
  
  cp5.addButton("direction_set")
  .setPosition(WINDOWX+50, 60)
  .setSize(30, 15)
  .setCaptionLabel("set");
  
  cp5.addButton("temp_plus")
  .setPosition(WINDOWX+10, 115)
  .setSize(15, 15)
  .setCaptionLabel("+");
  
  cp5.addButton("temp_minus")
  .setPosition(WINDOWX+30, 115)
  .setSize(15, 15)
  .setCaptionLabel("-");
  
  cp5.addButton("temp_set")
  .setPosition(WINDOWX+50, 115)
  .setSize(30, 15)
  .setCaptionLabel("set");
  
  cp5.addButton("hum_plus")
  .setPosition(WINDOWX+10, 210)
  .setSize(15, 15)
  .setCaptionLabel("+");
  
  cp5.addButton("hum_minus")
  .setPosition(WINDOWX+30, 210)
  .setSize(15, 15)
  .setCaptionLabel("-");
  
  cp5.addButton("hum_set")
  .setPosition(WINDOWX+50, 210)
  .setSize(30, 15)
  .setCaptionLabel("set");
  
  cp5.addButton("pres_plus")
  .setPosition(WINDOWX+10, 230)
  .setSize(15, 15)
  .setCaptionLabel("+");
  
  cp5.addButton("pres_minus")
  .setPosition(WINDOWX+30, 230)
  .setSize(15, 15)
  .setCaptionLabel("-");
  
  cp5.addButton("pres_set")
  .setPosition(WINDOWX+50, 230)
  .setSize(30, 15)
  .setCaptionLabel("set");
  
  cp5.addButton("co2_plus")
  .setPosition(WINDOWX+10, 305)
  .setSize(15, 15)
  .setCaptionLabel("+");
  
  cp5.addButton("co2_minus")
  .setPosition(WINDOWX+30, 305)
  .setSize(15, 15)
  .setCaptionLabel("-");
  
  cp5.addButton("co2_set")
  .setPosition(WINDOWX+50, 305)
  .setSize(30, 15)
  .setCaptionLabel("set");
  
  cp5.addToggle("system_switch")
  .setPosition(width-210, height-50)
  .setSize(100, 30)
  .setMode(ControlP5.SWITCH)
  .setColorCaptionLabel(0)
  .setCaptionLabel("U.S.");
  
  cp5.addButton("probe")
  .setPosition(650, height - 195)
  .setSize(100, 65)
  .setCaptionLabel("Use Lens");
  
  cp5.addButton("internet")
  .setPosition(755, height - 195)
  .setSize(100, 65)
  .setCaptionLabel("Enter ZIP");
  
  cp5.addButton("venus")
  .setPosition(1005, height-160)
  .setSize(100, 30)
  .setCaptionLabel("Venus");
  
  cp5.addButton("southpole")
  .setPosition(900, height-160)
  .setSize(100, 30)
  .setCaptionLabel("South Pole");
  
  cp5.addButton("sahara")
  .setPosition(900, height-195)
  .setSize(100, 30)
  .setCaptionLabel("Sahara Desert");
  
  cp5.addButton("rainforest")
  .setPosition(1005, height-195)
  .setSize(100, 30)
  .setCaptionLabel("Amazon");
  
  cp5.addButton("about")
  .setPosition(width - 105, height-50)
  .setSize(100, 30)
  .setCaptionLabel("About");
}

void GUIdraw() {
  
  DecimalFormat df = new DecimalFormat("0.00");
  
  float display_wind = wind_mph;
  float display_temp = temp_f;
  float display_windchill = windchill_f;
  float display_heatindex = heatindex_f;
  float display_dewpoint = dew_point_f;
  float display_warming = warming_f;
  float display_pressure = pressure_in;
  String distance_unit = " mph";
  String temp_unit = "\u00b0F";
  String units = "U.S";
  String pressure_unit = " inches";
  
  if (metric) {
    display_wind = wind_kph;
    display_temp = temp_c;
    display_windchill = windchill_c;
    display_heatindex = heatindex_c;
    display_dewpoint = dew_point_c;
    display_warming = warming_c;
    display_pressure = pressure;
    pressure_unit = " millibars";
    distance_unit = " kph";
    temp_unit = "\u00b0C";
  }
  
  fill(0);

  textSize(14);
  textAlign(RIGHT);
  text(wind_status, width-5, 25);
  text(dew_status, width-5, 195);
  text(temp_status, width-5, 100);
  text(fog_status, width-5, 263);
  
  textAlign(LEFT);
  text(status, WINDOWX + 5, height - 20);
  
  
  textSize(24);
  text("Real Air", 650, height - 202);
  text("Explore Biomes", 900, height - 202);
  text("Wind", WINDOWX+5, 30);
  textSize(14);
  text("Speed: " + df.format(display_wind) + distance_unit, WINDOWX+90, 53);
  text("Direction: " + direction_degrees + "\u00b0 from north", WINDOWX+90, 73);
  textSize(24);
  text("Temperature", WINDOWX+5, 105);
  textSize(14);
  text("Temperature: " + df.format(display_temp) + temp_unit, WINDOWX+90, 128);
  
  if (windchill_f != temp_f){
    text("Wind Chill: " + df.format(display_windchill) + temp_unit, WINDOWX+90, 148);
  } else if (heatindex_f != temp_f) {  
    text("Heat Index: " + df.format(display_heatindex) + temp_unit, WINDOWX+90, 148);
  }
    
  textSize(24);
  text("Humidity and Pressure", WINDOWX+5, 200);
  textSize(14);
  text("Relative Humidity: " + df.format(rel_hum*100) + "%", WINDOWX+90, 223);
  text("Barometric Pressure: "+ df.format(display_pressure) + pressure_unit, WINDOWX+90, 243);
  text("Dew Point: " + df.format(display_dewpoint) + temp_unit, WINDOWX+90, 263);
  textSize(24);
  text("Carbon Dioxide", WINDOWX+5, 295);
  textSize(14);
  text("Parts per Million: " + ceil(co2_prop * 1000000), WINDOWX+90, 318);
  text("Greenhouse Effect: " + df.format(display_warming) + temp_unit, WINDOWX+90, 338);
  
    
}