//Particles are a coordinate pair and an image
class Particle {
  float xpos, ypos;
  PImage img;
  
  Particle() {
    xpos = random(-50, WINDOWX+50);
    ypos = random(-50, height+50);
    img = getImage();
  }
 
 //Uses the air composition to determine each particle's image
 PImage getImage() {
   float rand = random(1);
   
   if (rand < water_prop) {
     return water;
   }
      
   rand = random(1);
   
   if (rand < co2_prop) {
     return co2;
   } else if (rand < co2_prop+oxygen_prop) {
     return oxygen;
   } else if (rand < co2_prop+oxygen_prop+argon_prop) {
     return argon;
   } else {
     return nitrogen;
   } 
   
 }
  
 //Consults the windspeed to update movement
  void update() {
    
    
    
    //Moves with the wind, vibrates with temperature
    xpos = xpos + wind.x + random(-temp_val, temp_val);
    ypos = ypos + wind.y + random(-temp_val, temp_val);
    
    //Refreshes at other side of screen when out of bounds
    if (xpos > WINDOWX + 60) {
      xpos = -50;
      ypos = random(height);
      img = getImage();
    } else if (xpos < -60) {
      xpos = WINDOWX+50;
      ypos = random(height);
      img = getImage();
    }
    
    if (ypos > height + 60) {
      ypos = -50;
      xpos = random(WINDOWX);
      img = getImage();
    } else if (ypos < -60) {
      ypos = height+50;
      xpos = random(WINDOWX);
      img = getImage();
    }
    
    //Draw the particle
    image(img, xpos, ypos);
  }
}